/**
 * Copyright (c) 2011 The Chromium Authors. All rights reserved.
 * Use of this source code is governed by a BSD-style license that can be
 * found in the LICENSE file.
 */

var speakKeyStr;
var start_text;
var end_text;
var min_words;
var include_title;
// var configVariable = new Array();

function speakSelection() {

  var title = document.getElementsByTagName("title");
  var ps = document.getElementsByTagName("P");
  var focused = document.activeElement;
  var selectedText;
  if (focused) {
      try {
        selectedText = focused.value.substring(
              focused.selectionStart, focused.selectionEnd);
      } catch (err) {
      }
  } 

  if (selectedText == undefined) {
    var sel = window.getSelection();
    var selectedText = sel.toString();
  } 

  if (!selectedText) {
    var strings = []
    if (title && include_title == 'true') {
      strings.push(start_text + ', ' + title[0].textContent.replace('|', ',') + ',')
    }
    for (index = 0; index < ps.length; ++index) {
      content = ps[index].textContent.replace('|', '.')
      if (strings.indexOf(content) < 0) {
        sentenceLength = content.split(' ').length
        if (sentenceLength > min_words) {
          strings.push(content + '.');
        }
      }
    }
    strings.push(end_text + '.')
    selectedText = strings.join(' ');
  }

  chrome.extension.sendRequest({'speak': selectedText});
}

function onExtensionMessage(request) {
  if (request['speakSelection'] != undefined) {
    if (!document.hasFocus()) {
      return;
    }
    speakSelection();
  } else if (request['key'] != undefined) {
    speakKeyStr = request['key'];
  }
}

function initContentScript() {
  chrome.extension.onRequest.addListener(onExtensionMessage);
  chrome.extension.sendRequest({'init': true}, onExtensionMessage);

  document.addEventListener('keydown', function(evt) {
    if (!document.hasFocus()) {
      return true;
    }
    var keyStr = keyEventToString(evt);
    if (keyStr == speakKeyStr && speakKeyStr.length > 0) {
      speakSelection();
      evt.stopPropagation();
      evt.preventDefault();
      return false;
    }
    return true;
  }, false);
  // var configOptions = ['start_text', 'end_text', 'min_words', 'include_title'];
  // var configVariable = [start_text, end_text, min_words, include_title];
  // for (index = 0; index < configOptions.length; ++index) {
  chrome.extension.sendMessage({method: "getLocalStorage", key: 'start_text'}, function(response) {
    // configVariable[index] = response.data;
    start_text = response.data || 'Now listening to';
    console.log(response.data);
  });
  chrome.extension.sendMessage({method: "getLocalStorage", key: 'end_text'}, function(response) {
    end_text = response.data || 'End article';
    console.log(response.data);
  });
  chrome.extension.sendMessage({method: "getLocalStorage", key: 'min_words'}, function(response) {
    min_words = response.data  || 4;
    console.log(response.data);
  });
  chrome.extension.sendMessage({method: "getLocalStorage", key: 'include_title'}, function(response) {
    include_title = response.data  || 'true';
    console.log(response.data);
  });
  // console.log(configVariable[0]);
  // }
}

initContentScript();
